QGIS Application - Bug report #18167

| have a modification to make r.mapcalc (grass7/processing toolbox) work with windows 7 and QGIS
Master (2.99...)

2018-02-21 03:56 PM - Olivier ATHIMON

Status: Closed

Priority: Normal

Assignee:

Category: Processing/GRASS

Affected QGIS version:master Regression?: No

Operating System: Windows Easy fix?: No

Pull Request or Patch supplied: Resolution: fixed/implemented
Crashes QGIS or corrupls data: Copied to github as #: 26058
Description

Hi,

| have a modification to make r.mapcalc (from QGIS/GRASS 7 processing toolbox) work with windows 7 and QGIS Master

(2.99...)

In the file : https://github.com/qgis/QGIS/blob/master/python/plugins/processing/algs/grass7/Grass7Algorithm.py

You should replace in "def exportRasterLayersIntoDirectory" :
for cmd in [self.commands, self.outputCommands]:
# TODO Windows support
# TODO Format/options support
cmd.append(“for r in $(g.list type=rast pattern='{}*'); do".format(basename))
cmd.append(" r.out.gdal -m{0} input=${{r}} output={1}/${{r}}.tif {2}".format(
'-t"if colorTable else ", outDir,
"--overwrite -c createopt="TFW=YES,COMPRESS=LZW"

)
)

cmd.append("done")

By this:
for cmd in [self.commands, self.outputCommands]:
# TODO Windows support
# TODO Format/options support
cmd.append("for /f %r in ('\"g.list type=rast\""); do r.out.gdal -m{0} input=%r output={1}/%%r.tif {2}".format(
'-t"if colorTable else ", outDir,
'--overwrite -c createopt=\"TFW=YES,COMPRESS=LZW\"

My modification gives this :
https://github.com/qgis/QGIS/blob/master/python/plugins/processing/algs/grass7/Grass7Algorithm.py

def exportRasterLayersintoDirectory(self, name, parameters, context, colorTable=True, wholeDB=False):

Creates a dedicated loop command to export rasters from
temporary GRASS DB into a directory via gdal.
:param name: name of the output directory parameter.
:param parameters: Algorithm parameters dict.
:param context: Algorithm context.
:param colorTable: preserve color Table.
:param wholeDB: export every raster layer from the GRASSDB
# Grab directory name and temporary basename
outDir = os.path.normpath(
self.parameterAsString(parameters, name, context))
basename ="
if not wholeDB:
basename = name + self.uniqueSuffix

# Add a loop export from the basename

for cmd in [self.commands, self.outputCommands]:
# TODO Windows support
# TODO Format/options support

cmd.append(“for /f %%r in (\"g.list type=rast\""); do r.out.gdal -m{0} input=%%r output={1}/%%r.tif {2}".format(
' +t'if colorTable else ", outDir,
‘—-overwrite -c createopt=\"TFW=YES,COMPRESS=LZW\""

)
)

Associated revisions

Revision b39e5a09 - 2018-11-11 03:15 AM - Jiirgen Fischer

processing: add windows support to exportRasterLayersIntoDirectory (fixes #20146)

History

#1 - 2018-02-21 03:58 PM - Giovanni Manghi

- Pull Request or Patch supplied changed from No to Yes
- Status changed from Open to Feedback

- Priority changed from High to Normal

Please file a pull request in the QGIS code repository. Thanks!

#2 - 2018-02-21 04:03 PM - Alexander Bruy
- Assignee deleted (Alexander Bruy)

#3 - 2018-02-21 11:36 PM - Olivier ATHIMON

Giovanni Manghi wrote:
Please file a pull request in the QGIS code repository. Thanks!

Idoit:

commit:e5981c9eb41f87f0827e14afb39361bb6abfc8e

https://github.com/qgis/QGIS/blob/e5981c9eb41{87f0827e14afb3936 1bb6ascfc8e/python/plugins/processing/algs/grass7/Grass7Algorithm.py

#4 - 2018-02-25 10:32 PM - Giovanni Manghi

Olivier ATHIMON wrote:

Giovanni Manghi wrote:

Please file a pull request in the QGIS code repository. Thanks!

Idoit:

commit:e5981c9eb41

https://github.com/qqis/QGIS/blob/e5981c9eb411f87f0827e 14afb3936 1bb6abfc8e/python/plugins/processing/algs/grass 7/Grass 7Algorithm.py

Hi,

| tested the code (on Windows) and it works which is of course very cool (despite the fact that using r.mapcalc is very cumbersome because is needed to

manually write the input file names and that the output is not added to the project).

| have anyway 2 questions:

is the code tested on Linux?

where is your PR?

| cannot find it here

https://github.com/qgis/QGIS/commits?author=ilikeqgis

is not among open or closed ones

https://github.com/qgis/QGIS/pulls

#5 - 2018-11-11 03:22 AM - Jiirgen Fischer
- Resolution set to fixed/implemented
- Status changed from Feedback to Closed

"duplicate" of #20146
